/* Original idea from Tab Mix Plus */

var TMDownload = {
  init : function () {
    let win = getTopWin();
    if (win) {
      let tb = win.gBrowser;
      let panelID = tb.mPanelContainer.lastChild.id;
      let tabToRemove;
      
      for ( let i = 0; i < tb.tabs.length; i++ ) {
        if ( tb.tabs[i].linkedPanel == panelID ) {
          tabToRemove = tb.tabs[i];
          break;
        }
      }
   
      // |downloadMangaer| == |false| if this is unknownContentType dialog window
      let downloadManager = document.getElementById("downloadManager");
      
      let dm = Components.classes["@mozilla.org/download-manager;1"]
                         .getService(Components.interfaces.nsIDownloadManager);
    
      if ( !downloadManager && tabToRemove.linkedBrowser.currentURI.spec == "about:blank" )
        tb.removeTab(tabToRemove);
    
      // This workaround is not the best solution.
      // It doesn't work when :
      //   1. |browser.download.manager.showWhenStarting| is set to |false|
      //      and unknownTypeContent window does not open. (Do something automatically without asking the user.)
      //   2. Download Manager is already opened.
      //
      if ( downloadManager && dm.activeDownloadCount && 
           tabToRemove.linkedBrowser.currentURI.spec == "about:blank" &&
           tabToRemove.linkedBrowser.contentDocument.getElementsByTagName("title").length == 0 )
        tb.removeTab(tabToRemove);
    }
  },
}

window.addEventListener("load", TMDownload.init, false);