/* 
 * pref-tabmix.js
 * for pref-tabmix.xul
 */

const gPref = Components.classes["@mozilla.org/preferences-service;1"].
              getService(Components.interfaces.nsIPrefBranch);

const __CloseButtonOnlyActiveTab = 0;
const __CloseButtonFirefoxNative = 1;
const __CloseButtonOnlyTabbar    = 3;
const __CloseButtonTabMixLite    = 4;

const __OpenInNewTab = 3;

// load all preferences into the dialog
function TM_PrefInit()
{
  TM_PrefCheckDisables();
}

function  TM_PrefVerifyWidth() {
  var minWidth = document.getElementById("minWidth");
  var maxWidth = document.getElementById("maxWidth");
  var tempWidth;
  
  if ( parseInt(minWidth.value) > parseInt(maxWidth.value) ) {
    tempWidth = minWidth.value;
    minWidth.value = maxWidth.value;
    maxWidth.value = tempWidth;
  }
}

function TM_PrefCheckDisables () {
  var openRelated = document.getElementById("browser.tabs.insertRelatedAfterCurrent");
  
  var enableGrouping = document.getElementById("choseTabGrouping");

  enableGrouping.disabled = !openRelated.value;
  if ( !openRelated.value )
    enableGrouping.value = false;
    
  var showMoveToGroup = document.getElementById("showMoveToGroup");
  showMoveToGroup.disabled = ( enableGrouping.value == "true" );
}

function TM_loadDefault () {
  var preferences = document.getElementsByTagName("preference");
  for ( var i=0; i < preferences.length; i++ ) {
    preferences[i].value = preferences[i].defaultValue;
  }
  TM_PrefCheckDisables();
}
